#include <stdio.h>
#include <stdlib.h>

void ucitaj(int n, int a[])
{
    int i;
    for(i=1; i<=n; i++)
    {
        scanf("%d", &a[i]);
    }
}

void ucitaj_m(int n, int m, int a[][2])
{
    int i,j;
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=m; j++)
        {
            scanf("%d", &a[i][j]);
        }
    }
}

int proveri(int n, int a[], int x, int y, int z)
{
    int i,rezerva;
    if(x==y)
    {
        return 1;
    }
    if(z!=0)
    {
        rezerva = a[z];
        a[z]=a[z-1];
    }
    else
    {
        rezerva=a[0];
        a[0]=a[1];
    }
    for(i=x; i<y; i++)
    {
        if(a[i]>a[i+1])
        {
            a[z]=rezerva;
            return 0;
        }
    }
    a[z]=rezerva;
    return 1;
}

int main()
{
    int n, a[30000],q;
    scanf("%d", &n);
    ucitaj(n,a);
    scanf("%d", &q);
    int b[q][2];
    ucitaj_m(q,2,b);
    for(int i=1;i<=q; i++)
    {
        int neopadajuci=0;
        for(int k=b[i][1]; k<=b[i][2]; k++)
        {
            if(proveri(n,a,b[i][1],b[i][2],k)==1)
            {
                printf("DA\n");
                neopadajuci=1;
                break;
            }
        }
        if(neopadajuci==0)
        {
            printf("NE\n");
        }
    }
    return 0;
}